require "numru/netcdf"
require "numru/dcl"
include NumRu
include NMath
require "statistics"
include Statistics
require "thermo_function"
include Thermo_Function
require "thermo_advanced_function"
include Thermo_Advanced_Function

z_ref = 1000.0    # Reference height (using CAPE)

# ǥǡե륪ץ
file = NetCDF.open('F2011052814S7100069.nc')
temp = file.var('temp').get
pres = file.var('pres').get
rh = file.var('RH').get
z = file.var('z').get

# 
qv = NArray.float(temp.total)
pt = NArray.float(temp.total)
ept = NArray.float(temp.total)
sept = NArray.float(temp.total)

nx = temp.total-2000

snd_linex = NArray.float(3)
snd_liney = NArray.float(3)

# ѿ׻
for i in 0..nx
   if temp[i] == 999.0 then  # »ͽ
      pt[i] = 999.0
      ept[i] = 999.0
      sept[i] = 999.0
   else
#  ǴؿƤӽФ. MKS ñ̤ˤʤäƤ뤳Ȥ.
      qv[i] = Thermo_Function.rhTP_2_qv( rh[i], temp[i], pres[i] )
      pt[i] = Thermo_Function.theta_dry( temp[i], pres[i] )
      ept[i] = Thermo_Function.thetae_Bolton( temp[i], qv[i], pres[i] )
      sept[i] = Thermo_Function.thetaes_Bolton( temp[i], pres[i] )
   end
end

zlcl=Thermo_Advanced_Function.z_LCL( z_ref, z, temp, pres, qv )
zlfc=Thermo_Advanced_Function.z_LFC( z_ref, z, temp, pres, qv )
zlnb=Thermo_Advanced_Function.z_LNB( z_ref, z, temp, pres, qv, opt=2 )
pwv=Thermo_Advanced_Function.precip_water( pres, qv )
capev=Thermo_Advanced_Function.cape( z_ref, z, temp, pres, qv, opt=2, error=999.0 )
cinv=Thermo_Advanced_Function.cin( z_ref, z, temp, pres, qv, error=999.0  )
print "---------------------------------\n"
printf("%8s", "CAPE  = ")
printf("%10f", capev)
printf("%8s\n", " [J/kg].")
printf("%8s", "CIN   = ")
printf("%10f", cinv)
printf("%8s\n", " [J/kg].")
printf("%8s", "PW    = ")
printf("%10f", pwv)
printf("%8s\n", "   [mm].")
printf("%8s", "z_ref = ")
printf("%10f", z_ref)
printf("%8s\n", "    [m].")
printf("%8s", "LCL   = ")
printf("%10f", zlcl)
printf("%8s\n", "    [m].")
printf("%8s", "LFC   = ")
printf("%10f", zlfc)
printf("%8s\n", "    [m].")
printf("%8s", "LNB   = ")
printf("%10f", zlnb)
printf("%8s\n", "    [m].")
print "---------------------------------\n"

iz_snd = Statistics.interpo_search_1d( z, z_ref )
snd_linex[0] = Statistics.interpolation_1d( z[iz_snd], z[iz_snd+1], ept[iz_snd], ept[iz_snd+1], z_ref )
iz_snd = Statistics.interpo_search_1d( z, zlfc )
snd_linex[1] = Statistics.interpolation_1d( z[iz_snd], z[iz_snd+1], sept[iz_snd], sept[iz_snd+1], zlfc )
iz_snd = Statistics.interpo_search_1d( z, zlnb )
snd_linex[2] = Statistics.interpolation_1d( z[iz_snd], z[iz_snd+1], sept[iz_snd], sept[iz_snd+1], zlnb )
snd_liney[0..2] = [z_ref, zlfc, zlnb]

# ʲ DCL ¦ν

DCL.gllset( 'lmiss', 'true' )
DCL.uzfact( 0.7 )
DCL.sgiset('IFONT', 2 )

puts 'device number [1,2,3,4 ?]'
num = gets

DCL.gropn(num)
DCL.grfrm
DCL.ussttl( 'temperature', 'K', 'altitude', 'm' )
DCL.grsvpt( 0.3, 0.75, 0.2, 0.8)
DCL.usspnt( pt[0..nx], z[0..nx] )
DCL.usspnt( ept[0..nx], z[0..nx] )
DCL.usspnt( sept[0..nx], z[0..nx] )
DCL.usspnt( snd_linex[0..1], snd_liney[0..1] )
DCL.usspnt( snd_linex[1..2], snd_liney[1..2] )
DCL.uspfit
DCL.grstrf
DCL.usdaxs
DCL.uulinz( pt[0..nx], z[0..nx], 1, 12 )
DCL.uulinz( ept[0..nx], z[0..nx], 1, 22 )
DCL.uulinz( sept[0..nx], z[0..nx], 1, 32 )
DCL.uulinz( snd_linex[0..1], snd_liney[0..1], 2, 12 )
DCL.uulinz( snd_linex[1..2], snd_liney[1..2], 2, 12 )
DCL.uumrkz( snd_linex[0..0], snd_liney[0..0], 3, 6, 0.02 )
DCL.uumrkz( snd_linex[1..1], snd_liney[1..1], 10, 6, 0.02 )
DCL.uumrkz( snd_linex[2..2], snd_liney[2..2], 16, 6, 0.02 )
DCL.grcls
